import { useEffect, useState } from 'react';
import useEvent from 'react-use-event-hook';

function refsInitialState() {
  return {
    resolve: null
  };
}

function useStateWithPromise(initialState) {
  const [state, setState] = useState(initialState);
  const [$refs] = useState(refsInitialState);
  useEffect(() => {
    if ($refs.resolve) $refs.resolve(state);
  }, [$refs, state]);
  const setStateWithPromise = useEvent(stateAction => {
    setState(stateAction);
    return new Promise(resolve => {
      $refs.resolve = resolve;
    });
  });
  return [state, setStateWithPromise];
}

export default useStateWithPromise;